//package org.processmining.timebasedabstraction.visualization;
//
//import java.awt.BasicStroke;
//import java.awt.BorderLayout;
//import java.awt.Color;
//import java.awt.Dimension;
//import java.awt.GridLayout;
//import java.awt.MouseInfo;
//import java.awt.event.ActionEvent;
//import java.awt.event.ActionListener;
//import java.awt.event.ItemEvent;
//import java.awt.event.ItemListener;
//import java.lang.reflect.Field;
//import java.util.ArrayList;
//import java.util.Collection;
//import java.util.Collections;
//import java.util.List;
//import java.util.Map;
//import java.util.TreeMap;
//import java.util.concurrent.Executor;
//
//import javax.swing.Box;
//import javax.swing.BoxLayout;
//import javax.swing.ImageIcon;
//import javax.swing.JButton;
//import javax.swing.JCheckBox;
//import javax.swing.JComboBox;
//import javax.swing.JComponent;
//import javax.swing.JLabel;
//import javax.swing.JPanel;
//import javax.swing.JScrollPane;
//import javax.swing.JSplitPane;
//import javax.swing.JTabbedPane;
//import javax.swing.JTextField;
//import javax.swing.border.EmptyBorder;
//
//import org.deckfour.uitopia.api.model.ResourceType;
//import org.deckfour.xes.model.XLog;
//import org.jfree.chart.ChartFactory;
//import org.jfree.chart.ChartPanel;
//import org.jfree.chart.JFreeChart;
//import org.jfree.chart.plot.PlotOrientation;
//import org.jfree.chart.plot.XYPlot;
//import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
//import org.jfree.data.xy.XYDataset;
//import org.jfree.data.xy.XYSeries;
//import org.jfree.data.xy.XYSeriesCollection;
//import org.processmining.contexts.uitopia.UIContext;
//import org.processmining.contexts.uitopia.UIPluginContext;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.contexts.uitopia.annotations.Visualizer;
//import org.processmining.contexts.uitopia.model.ProMPOResource;
//import org.processmining.contexts.uitopia.model.ProMTask;
//import org.processmining.framework.plugin.GlobalContext;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.framework.providedobjects.ProvidedObjectID;
//import org.processmining.plugins.utils.ProvidedObjectHelper;
//import org.processmining.timebasedabstraction.algorithms.ElbowMethod;
//import org.processmining.timebasedabstraction.algorithms.KMeans;
//import org.processmining.timebasedabstraction.models.TimeAndCountModel;
//import org.processmining.timebasedabstraction.parameters.Parameters;
//import org.processmining.timebasedabstraction.plugins.CreateAbstractedLog;
//import org.processmining.timebasedabstraction.plugins.TimeAndCountPlugin;
//import org.tc33.jheatchart.HeatChart;
//
//import com.fluxicon.slickerbox.components.NiceDoubleSlider;
//import com.fluxicon.slickerbox.components.NiceSlider.Orientation;
//import com.fluxicon.slickerbox.factory.SlickerDecorator;
//import com.fluxicon.slickerbox.factory.SlickerFactory;
//
////@Plugin(name = "Show Cluster Visualization", returnLabels = {"Cluster Visualization"},
////returnTypes = {JComponent.class}, parameterLabels = {"TimeAndCountModel"},
////userAccessible = true)
////@Visualizer
//public class SessionsVisualizer3 {
//	UIPluginContext globalContext;
//	TimeAndCountModel globalModel;
//	
//	CreateAbstractedLog createAbstractLog;
//
//	JSplitPane entireView = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT);
//	JSplitPane tabSplitPane;
//	JSplitPane resultSplitPane;
//
//	// Create JTabbedPane
//	JTabbedPane tabbedPane;
//
//	public Map<Integer, String> clusterNameMap;
//	public Map<Integer, Integer> indexToClusterMap;
//
//	private SlickerFactory slickerFactory;
//	private SlickerDecorator slickerDecorator;
//
//	private JButton startButton;
//	private JButton chartButton;
//	private JButton exportButton;
//
//	private JComboBox<String> modeList;
//	private JComboBox<Integer> clusterNumbersList;
//	
//	private JCheckBox checkbox;
//
//	private JLabel modeLabel;
//	private JLabel clusterNumberLabel;
//	private JLabel thresholdLabel;
//	private JLabel topEventsLabel;
//	private JLabel imageLabel;
//
//	private ImageIcon icon;
//
//	private JPanel headPanel;
//	private JPanel leftPane;
//	private JPanel boxButtonPanel;
//
//	private ChartPanel chartPanelTime;
//	private ChartPanel chartPanelCount;
//	private ChartDialog chartDialog;
//
//	ElbowMethod elbow = new ElbowMethod();
//	KMeans kmeans = new KMeans();
//	HeatChart heatmap;
//
//	double[] sqErrorsTime;
//	double[] sqErrorsCount;
//	int numberOfTabs = 1;
//	boolean countFlag = false;
//	List<JTextField> textFields;
//
//	//	@PluginVariant(requiredParameterLabels = {0} )
//	@Plugin(name = "Show Cluster Visualization", returnLabels = {"Cluster Visualization"},
//			returnTypes = {JComponent.class}, parameterLabels = {"TimeAndCountModel"},
//			userAccessible = true)
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "S. Dündar", email = "s.dundar@student.tue.nl")
//	@Visualizer(name = "hoi")
//	public JComponent visualize(UIPluginContext context, TimeAndCountModel model) throws Exception {
//		globalContext = context;
//		globalModel = model;
//
//		slickerFactory = SlickerFactory.instance();
//		slickerDecorator = SlickerDecorator.instance();
//
//		// Return the results in headpanel
//		headPanel = new JPanel(new BorderLayout());
//		entireView.setOpaque(false);
//		entireView.setOneTouchExpandable(true);
//
//		// create the tabbedPane
//		tabbedPane = new JTabbedPane();
//
//		// First of all compute the squared errors for the elbow graph
//		// for both time and count models
//		sqErrorsTime = elbow.run(globalModel.getDataSet());
//		chartPanelTime = createElbowChartTime(sqErrorsTime);
//
//		entireView.setRightComponent(tabbedPane);
//
//		// Left panel: Dimension selection and calculate button
//		leftPane = new JPanel();
//		leftPane.setPreferredSize(new Dimension(250, 80));
//		leftPane.setBackground(Color.DARK_GRAY);
//		leftPane.setForeground(Color.WHITE);
//		leftPane.setLayout(new BoxLayout(leftPane, BoxLayout.PAGE_AXIS));
//		leftPane.setBorder(new EmptyBorder(15, 5, 5, 15));
//
//		// Cluster Mode Information
//		modeLabel = slickerFactory.createLabel("Select Clustering Mode");
//		modeLabel.setForeground(leftPane.getForeground());
//		leftPane.add(modeLabel);
//
//		// ComboBox Mode information
//		modeList = slickerFactory.createComboBox(new String[] {"Time Sessions Clustering", "Count Sessions Clustering"});
//		slickerDecorator.decorate(modeList);
//		modeList.addItemListener(new ItemListener() {
//			public void itemStateChanged(ItemEvent evt) {
//				JComboBox comboBox = (JComboBox) evt.getSource();
//				Object item = evt.getItem();
//				if (evt.getStateChange() == ItemEvent.SELECTED) {
//					try {
//						if (modeList.getSelectedItem().equals("Time Sessions Clustering")) {
//							chartPanelTime = createElbowChartTime(sqErrorsTime);
//						} else if (modeList.getSelectedItem().equals("Count Sessions Clustering")) {
//							if (countFlag == false) {
//								chartPanelCount = runCountModel();
//								//								chartPanelCount = createElbowChartCount(sqErrorsCount);
//							}
//						}
//					} catch (Exception e) {
//
//					}
//				}
//			}
//		});
//		leftPane.add(modeList);
//
//		// Insert margin
//		leftPane.add(Box.createRigidArea(new Dimension(0, 15)));
//
//		boxButtonPanel = new JPanel();
//		boxButtonPanel.setBackground(leftPane.getBackground());
//		boxButtonPanel.setForeground(leftPane.getForeground());
//		boxButtonPanel.setLayout(new BoxLayout(boxButtonPanel, BoxLayout.LINE_AXIS));
//
//		// Number of Cluster Selection Information
//		clusterNumberLabel = slickerFactory.createLabel("Select number of clusters");
//		clusterNumberLabel.setForeground(leftPane.getForeground());
//		leftPane.add(clusterNumberLabel);
//
//		Integer[] clusterNumbs = new Integer[20];
//		for (int i = 0; i < clusterNumbs.length; i++) {
//			clusterNumbs[i] = i + 1;
//		}
//		clusterNumbersList = slickerFactory.createComboBox(clusterNumbs);
//		clusterNumbersList.setPreferredSize(new Dimension(0, 10));
//		slickerDecorator.decorate(clusterNumbersList);
//		boxButtonPanel.add(clusterNumbersList);
//		leftPane.add(boxButtonPanel);
//
//		clusterNumbersList.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				JComboBox cb = (JComboBox) e.getSource();
//				int clusterNumber = (int) cb.getSelectedItem();
//				kmeans.setNumberOfClusters(clusterNumber);
//			}
//		});
//
//		// Insert margin
//		leftPane.add(Box.createRigidArea(new Dimension(0, 15)));
//
//		// The Start Clustering Button
//		startButton = slickerFactory.createButton("Generate Heatmap");
//		startButton.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//
//				final Parameters parameters = new Parameters();
//				//				final UIPluginContext child = globalContext.createChildContext("child");
//				Executor exec = globalContext.getExecutor();
//
//				Runnable task = new Runnable() {
//					public void run() {
//						// Change the button name to show it's doing something
//						startButton.setText("Generating Heatmap...");
//
//						TimeAndCountPlugin plugin = new TimeAndCountPlugin();
//						plugin.setMode((String) modeList.getSelectedItem());
//						TimeAndCountModel model = plugin.mineParameters(globalContext, globalModel.getEventLog(), parameters);
//						createAbstractLog = new CreateAbstractedLog();
//
//						// Run the Kmeans algorithm
//						try {
//							kmeans.buildIt(model.getDataSet());
//						} catch (Exception e1) {
//
//						}
//
//						// ColourScale Selection ComboBox
//						JComboBox<String> colourScaleList = slickerFactory.createComboBox(new String[] {"Logarithmic", "Linear", "Exponential"});
//						slickerDecorator.decorate(colourScaleList);
//
//						final NiceDoubleSlider thresholdSliderNice = slickerFactory.createNiceDoubleSlider("", kmeans.getMinValue(), kmeans.getMaxValue(), kmeans.getMinValue(), Orientation.HORIZONTAL);
//						final JButton updateButton = slickerFactory.createButton("Update Heatmap");
//						final JButton exportButton = slickerFactory.createButton("Generate Abstracted Log");
//						checkbox = slickerFactory.createCheckBox("Enable Numbering", false);
//
//						JPanel leftTabPane = new JPanel();
//						leftTabPane.setPreferredSize(new Dimension(250, 90));
//						leftTabPane.setLayout(new BoxLayout(leftTabPane, BoxLayout.PAGE_AXIS));
//
//						leftTabPane.add(Box.createRigidArea(new Dimension(0, 50)));
//						leftTabPane.add(slickerFactory.createLabel("Clustering Mode: " + modeList.getSelectedItem()));
//						leftTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//						leftTabPane.add(slickerFactory.createLabel("Selected Number of Clusters: " + clusterNumbersList.getSelectedItem()));
//						leftTabPane.add(Box.createRigidArea(new Dimension(0, 50)));
//						leftTabPane.add(slickerFactory.createLabel("Choose Heatmap Colouring Scale"));
//						leftTabPane.add(colourScaleList);
//						leftTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//						leftTabPane.add(slickerFactory.createLabel("Select Threshold Value"));
//						leftTabPane.add(thresholdSliderNice);
//						leftTabPane.add(Box.createRigidArea(new Dimension(0, 15)));
//						leftTabPane.add(updateButton);
//						leftTabPane.add(Box.createRigidArea(new Dimension(0,100)));
//						leftTabPane.add(checkbox);
//						leftTabPane.add(exportButton);						
//
//						String cs = (String) colourScaleList.getSelectedItem();
//						heatmap = createHeatmap(kmeans, cs);
//						icon = new ImageIcon(heatmap.getChartImage());
//						imageLabel = new JLabel(icon);
//
//						JPanel clusterPanel = new JPanel();
//						//						List<JTextField> textFields = new ArrayList<JTextField>();
//						textFields = new ArrayList<JTextField>();
//						for (int i = 0; i < kmeans.getNumberOfClusters(); i++) {
//							JLabel label = new JLabel("Cluster " + i + ": ");
//							JTextField textField = new JTextField(20);
//							label.setLabelFor(textField);
//							clusterPanel.setLayout(new GridLayout(kmeans.getNumberOfClusters(), kmeans.getNumberOfClusters()));
//							clusterPanel.add(label);
//							clusterPanel.add(textField);
//							textFields.add(textField);
//						}
//						JScrollPane rightTabScroll = new JScrollPane(imageLabel);
//						resultSplitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, rightTabScroll, clusterPanel);
//						resultSplitPane.setResizeWeight(0.6);
//
//						tabSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, leftTabPane, resultSplitPane);
//						tabSplitPane.setOpaque(false);
//						tabSplitPane.setOneTouchExpandable(true);
//
//						updateButton.addActionListener(new ActionListener() {
//							public void actionPerformed(ActionEvent evt) {
//								try {
//									kmeans.setActualThresholdValue((float) thresholdSliderNice.getValue());
//									kmeans.runFiltered(model.getDataSet());
//								} catch (Exception e) {
//								}
//								String cs = (String) colourScaleList.getSelectedItem();
//								heatmap = createHeatmap(kmeans, cs);
//								icon = new ImageIcon(heatmap.getChartImage());
//								imageLabel = new JLabel(icon);
//								JScrollPane rightTabScroll = new JScrollPane(imageLabel);
//								resultSplitPane.setLeftComponent(rightTabScroll);
//							}							
//						});
//
//						exportButton.addActionListener(new ActionListener() {
//							public void actionPerformed(ActionEvent e) {
//								exportButton.setText("Creating Abstracted Log...");
//
//								clusterNameMap = new TreeMap<Integer, String>();
//								for (int i = 0; i < textFields.size(); i++) {
//									//									String eventName = textFields.get(i).getText();
//									//									System.out.println(eventName);
//									clusterNameMap.put(i, textFields.get(i).getText());
//								}
//								globalModel.setClusterNameMap(clusterNameMap);
//								System.out.println(clusterNameMap);
//
//								int[] assignments = kmeans.getClusterAssignments();
//								indexToClusterMap = new TreeMap<Integer, Integer>();
//								for (int i = 0; i < assignments.length; i++) {
//									//									System.out.println(assignments[i]);
//									indexToClusterMap.put(i, assignments[i]);
//								}
//								globalModel.setIndexToClusterMap(indexToClusterMap);
//								System.out.println(indexToClusterMap);
//								
//								XLog abstractLog = createAbstractLog.mineAbstractLog(globalModel.getEventLog(), globalModel);
//								
//								publish(globalContext, "Created Abstract Log", abstractLog, XLog.class, true);
//								
//								exportButton.setText("Abstracted Log Created");
//							}
//						});
//						
//						checkbox.addActionListener(new ActionListener() {
//							public void actionPerformed(ActionEvent evt) {
//								JCheckBox cbLog = (JCheckBox) evt.getSource();
//								if (cbLog.isSelected()) {
//									createAbstractLog.setWithNumbers(true);
//								} else {
//									createAbstractLog.setWithNumbers(false);
//								}
//							}							
//						});
//
//						tabbedPane.addTab("Tab " + numberOfTabs, tabSplitPane);
//						tabbedPane.setSelectedIndex(numberOfTabs - 1);
//						numberOfTabs++;
//
//						startButton.setText("Generate Heatmap");
//					}
//				};
//				exec.execute(task);
//			}
//		});
//		leftPane.add(startButton);
//
//		// Insert margin
//		leftPane.add(Box.createRigidArea(new Dimension(0, 15)));
//
//		chartButton = slickerFactory.createButton("Elbow Graph");
//		chartButton.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent evt) {
//				try {
//					if (modeList.getSelectedItem().equals("Time Sessions Clustering")) {
//						chartDialog = new ChartDialog(chartPanelTime);
//					} else if (modeList.getSelectedItem().equals("Count Sessions Clustering")) {
//						chartDialog = new ChartDialog(chartPanelCount);
//					}
//					if (chartDialog != null) {
//						chartDialog.setAlwaysOnTop(true);
//						chartDialog.setLocation(MouseInfo.getPointerInfo().getLocation());
//						chartDialog.setVisible(true);
//					}
//				} catch (Exception e) {
//
//				}
//			}
//		});
//		boxButtonPanel.add(chartButton);
//
//		/*
//		 * Wrap everything together and return
//		 */
//		entireView.setLeftComponent(leftPane);
//		headPanel.add(entireView, BorderLayout.CENTER);
//
//		return headPanel;
//	}
//
//	private ChartPanel createElbowChartTime(double[] sqErrorsTime) {
//		XYDataset dataset = createDatasetTime();
//
//		JFreeChart chart = ChartFactory.createXYLineChart("The Elbow Method Time", 
//				"Number of Clusters", "Within Sum of Squared Errors", 
//				dataset,
//				PlotOrientation.VERTICAL, true, true, false);
//
//		// Customize the chart
//		XYPlot plot = chart.getXYPlot();
//		XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
//
//		renderer.setSeriesPaint(0, Color.RED);
//		renderer.setSeriesPaint(1, Color.BLACK);
//		renderer.setSeriesStroke(0, new BasicStroke(3.0f));
//
//		plot.setRenderer(renderer);
//		plot.setBackgroundPaint(Color.DARK_GRAY);
//		plot.setRangeGridlinesVisible(true);
//		plot.setRangeGridlinePaint(Color.BLACK);
//		plot.setDomainGridlinesVisible(true);
//		plot.setDomainGridlinePaint(Color.BLACK);
//
//		// Create the ChartPanel
//		ChartPanel panel = new ChartPanel(chart);
//
//
//		return panel;
//	}
//
//	private XYDataset createDatasetTime() {
//		XYSeriesCollection dataset = new XYSeriesCollection();
//		XYSeries series = new XYSeries("Within Sum of Squared Errors");
//		for (int i = 0; i < sqErrorsTime.length; i++) {
//			series.add(i + 1, sqErrorsTime[i]);
//		}
//
//		XYSeries series2 = new XYSeries("Straight Line");
//		series2.add(1, sqErrorsTime[0]);
//		series2.add(20, sqErrorsTime[19]);
//
//		// Add series to dataset
//		dataset.addSeries(series);
//		dataset.addSeries(series2);
//
//		return dataset;
//	}
//
//	private ChartPanel createElbowChartCount(double[] sqErrorsCount) {
//		XYDataset dataset = createDatasetCount();
//
//		JFreeChart chart = ChartFactory.createXYLineChart("The Elbow Method Count", 
//				"Number of Clusters", "Within Sum of Squared Errors", 
//				dataset,
//				PlotOrientation.VERTICAL, true, true, false);
//
//		// Customize the chart
//		XYPlot plot = chart.getXYPlot();
//		XYLineAndShapeRenderer renderer = new XYLineAndShapeRenderer();
//
//		renderer.setSeriesPaint(0, Color.RED);
//		renderer.setSeriesPaint(1, Color.BLACK);
//		renderer.setSeriesStroke(0, new BasicStroke(3.0f));
//
//		plot.setRenderer(renderer);
//		plot.setBackgroundPaint(Color.DARK_GRAY);
//		plot.setRangeGridlinesVisible(true);
//		plot.setRangeGridlinePaint(Color.BLACK);
//		plot.setDomainGridlinesVisible(true);
//		plot.setDomainGridlinePaint(Color.BLACK);
//
//		// Create the ChartPanel
//		ChartPanel panel = new ChartPanel(chart);
//
//		return panel;
//	}
//
//	private XYDataset createDatasetCount() {
//		XYSeriesCollection dataset = new XYSeriesCollection();
//		XYSeries series = new XYSeries("Within Sum of Squared Errors");
//		for (int i = 0; i < sqErrorsCount.length; i++) {
//			series.add(i + 1, sqErrorsCount[i]);
//		}
//
//		XYSeries series2 = new XYSeries("Straight Line");
//		series2.add(1, sqErrorsCount[0]);
//		series2.add(20, sqErrorsCount[19]);
//
//		// Add series to dataset
//		dataset.addSeries(series);
//		dataset.addSeries(series2);
//
//		return dataset;
//	}
//
//	private HeatChart createHeatmap(KMeans kmeans, String colourScale) {
//		heatmap = new HeatChart(kmeans.getMatrix());
//		heatmap.setTitle("Clustering Results");
//		heatmap.setXValues(kmeans.getClusters().toArray());
//		heatmap.setXAxisLabel("Cluster");
//		heatmap.setYValues(kmeans.getAttributeNames().toArray());
//		heatmap.setYAxisLabel("Event");
//
//		if (colourScale.equals("Logarithmic")) {
//			heatmap.setColourScale(heatmap.SCALE_LOGARITHMIC);
//		} else if (colourScale.equals("Linear")) {
//			heatmap.setColourScale(heatmap.SCALE_LINEAR);
//		} else if (colourScale.equals("Exponential")) {
//			heatmap.setColourScale(heatmap.SCALE_EXPONENTIAL);
//		}
//
//		heatmap.setHighValueColour(Color.RED);
//		return heatmap;
//	}
//
//	private ChartPanel runCountModel() throws Exception {
//		TimeAndCountPlugin plugin = new TimeAndCountPlugin();
//		TimeAndCountModel modelCount = plugin.mineParametersCount(globalContext, globalModel.getEventLog(), new Parameters());
//		sqErrorsCount = elbow.run(modelCount.getDataSet());
//		chartPanelCount = createElbowChartCount(sqErrorsCount);
//		countFlag = true;
//
//		return chartPanelCount;
//	}
//
//	private static <T> void publish(final PluginContext context, final String name, final T object,
//			final Class<? super T> clazz, final boolean favorite) {
//		final ProvidedObjectID id = context.getProvidedObjectManager().createProvidedObject(name, object, clazz, context);
//
//		if (context instanceof UIPluginContext) {
//			final GlobalContext gcontext = ((UIPluginContext) context).getGlobalContext();
//			if (gcontext instanceof UIContext) {
//				final UIContext uicontext = (UIContext) gcontext;
//				final ResourceType resType = uicontext.getResourceManager().getResourceTypeFor(clazz);
//				if (resType != null) {
//					ProMTask task = null;
//					try {
//						final Field taskField = context.getClass().getDeclaredField("task");
//						taskField.setAccessible(true);
//						task = (ProMTask) taskField.get(context);
//					} catch (final Exception _) {
//						// Guess it wasn't meant to be, then...
//					}
//					final List<Collection<ProMPOResource>> lst = Collections.emptyList();
//					ProMPOResource res = new ProMPOResource(uicontext, task == null ? null : task.getAction(), resType, 
//							id, lst);
//					res = uicontext.getResourceManager().addResource(id, res);
//				}
//			}
//		}
//		if (favorite) {
//			ProvidedObjectHelper.setFavorite(context, object);
//		}
//	}
//
//}
